# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetTacacsServerProfileResult',
    'AwaitableGetTacacsServerProfileResult',
    'get_tacacs_server_profile',
    'get_tacacs_server_profile_output',
]

@pulumi.output_type
class GetTacacsServerProfileResult:
    """
    A collection of values returned by getTacacsServerProfile.
    """
    def __init__(__self__, id=None, protocol=None, servers=None, tfid=None, timeout=None, use_single_connection=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if protocol and not isinstance(protocol, str):
            raise TypeError("Expected argument 'protocol' to be a str")
        pulumi.set(__self__, "protocol", protocol)
        if servers and not isinstance(servers, list):
            raise TypeError("Expected argument 'servers' to be a list")
        pulumi.set(__self__, "servers", servers)
        if tfid and not isinstance(tfid, str):
            raise TypeError("Expected argument 'tfid' to be a str")
        pulumi.set(__self__, "tfid", tfid)
        if timeout and not isinstance(timeout, int):
            raise TypeError("Expected argument 'timeout' to be a int")
        pulumi.set(__self__, "timeout", timeout)
        if use_single_connection and not isinstance(use_single_connection, bool):
            raise TypeError("Expected argument 'use_single_connection' to be a bool")
        pulumi.set(__self__, "use_single_connection", use_single_connection)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The Id param.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def protocol(self) -> str:
        """
        The Protocol param. String must be one of these: `"CHAP"`, `"PAP"`.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def servers(self) -> Sequence['outputs.GetTacacsServerProfileServerResult']:
        """
        The Servers param.
        """
        return pulumi.get(self, "servers")

    @property
    @pulumi.getter
    def tfid(self) -> str:
        return pulumi.get(self, "tfid")

    @property
    @pulumi.getter
    def timeout(self) -> int:
        """
        The Timeout param. Value must be between 1 and 30.
        """
        return pulumi.get(self, "timeout")

    @property
    @pulumi.getter(name="useSingleConnection")
    def use_single_connection(self) -> bool:
        """
        The UseSingleConnection param.
        """
        return pulumi.get(self, "use_single_connection")


class AwaitableGetTacacsServerProfileResult(GetTacacsServerProfileResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTacacsServerProfileResult(
            id=self.id,
            protocol=self.protocol,
            servers=self.servers,
            tfid=self.tfid,
            timeout=self.timeout,
            use_single_connection=self.use_single_connection)


def get_tacacs_server_profile(id: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTacacsServerProfileResult:
    """
    Retrieves a config item.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_scm as scm

    example = scm.get_tacacs_server_profile(id="1234-56-789")
    ```


    :param str id: The Id param.
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('scm:index/getTacacsServerProfile:getTacacsServerProfile', __args__, opts=opts, typ=GetTacacsServerProfileResult).value

    return AwaitableGetTacacsServerProfileResult(
        id=pulumi.get(__ret__, 'id'),
        protocol=pulumi.get(__ret__, 'protocol'),
        servers=pulumi.get(__ret__, 'servers'),
        tfid=pulumi.get(__ret__, 'tfid'),
        timeout=pulumi.get(__ret__, 'timeout'),
        use_single_connection=pulumi.get(__ret__, 'use_single_connection'))
def get_tacacs_server_profile_output(id: Optional[pulumi.Input[str]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTacacsServerProfileResult]:
    """
    Retrieves a config item.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_scm as scm

    example = scm.get_tacacs_server_profile(id="1234-56-789")
    ```


    :param str id: The Id param.
    """
    __args__ = dict()
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('scm:index/getTacacsServerProfile:getTacacsServerProfile', __args__, opts=opts, typ=GetTacacsServerProfileResult)
    return __ret__.apply(lambda __response__: GetTacacsServerProfileResult(
        id=pulumi.get(__response__, 'id'),
        protocol=pulumi.get(__response__, 'protocol'),
        servers=pulumi.get(__response__, 'servers'),
        tfid=pulumi.get(__response__, 'tfid'),
        timeout=pulumi.get(__response__, 'timeout'),
        use_single_connection=pulumi.get(__response__, 'use_single_connection')))
